/** MIT License
* 
* Copyright (c) 2018 Ludovic CLUBER 
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* http://csvxjs.lcluber.com
*/

var CSVx=function(e){"use strict";function r(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}function i(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}function o(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}var n=function(){function r(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,n,t){return n&&r(e.prototype,n),t&&r(e,t),e}}(),t=function(){function e(){!function(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}(this,e)}return n(e,null,[{key:"get",value:function(e){return this.call("GET",e)}},{key:"head",value:function(e){return this.call("HEAD",e)}},{key:"post",value:function(e){return this.call("POST",e)}},{key:"put",value:function(e){return this.call("PUT",e)}},{key:"delete",value:function(e){return this.call("DELETE",e)}},{key:"connect",value:function(e){return this.call("CONNECT",e)}},{key:"options",value:function(e){return this.call("OPTIONS",e)}},{key:"trace",value:function(e){return this.call("TRACE",e)}},{key:"patch",value:function(e){return this.call("PATCH",e)}},{key:"call",value:function(r,i){var o=this;return new Promise(function(e,n){var t=new XMLHttpRequest;o.noCache&&(i+="?cache="+(new Date).getTime()),t.open(r,i,o.async),t.setRequestHeader("Content-Type","application/x-www-form-urlencoded"),t.onreadystatechange=function(){4==t.readyState&&(200==t.status?e(t.responseText):n(t.status))},t.send()})}}]),e}();t.async=!0,t.noCache=!1;var u="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},a=function(){function r(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,n,t){return n&&r(e.prototype,n),t&&r(e,t),e}}(),l=function(){function e(){r(this,e)}return a(e,null,[{key:"isJSON",value:function(e){if(!this.isString(e))return!1;var n=e.replace(/(\r\n|\n|\r|\t)/gm,"");try{n=JSON.parse(e)}catch(e){return!1}return n}},{key:"isFunction",value:function(e){return e&&"[object Function]"==={}.toString.call(e)}},{key:"isObject",value:function(e){return null!==e&&"object"===(void 0===e?"undefined":u(e))}},{key:"isASCII",value:function(e,n){return(n?/^[\x00-\xFF]*$/:/^[\x00-\x7F]*$/).test(e)}},{key:"isInteger",value:function(e){return e===parseInt(e,10)}},{key:"isString",value:function(e){return"string"==typeof e}}]),e}(),c=function(){function e(){r(this,e)}return a(e,null,[{key:"scrollToBottom",value:function(e){e.scrollTop=e.scrollHeight}},{key:"findById",value:function(e){return document.getElementById(e)}},{key:"showById",value:function(e){this.findById(e).style.display="block"}},{key:"hideById",value:function(e){this.findById(e).style.display="none"}},{key:"showOverflow",value:function(){document.body.style.overflow="visible"}},{key:"hideOverflow",value:function(){document.body.style.overflow="hidden"}},{key:"getInputValue",value:function(e){return this.findById(e).value}},{key:"clearInputValue",value:function(e){this.findById(e).value=""}},{key:"focusOn",value:function(e){this.findById(e).focus()}},{key:"addHTMLElement",value:function(e,n,t){var r=document.createElement(n);return void 0!==t&&Object.keys(t).forEach(function(e){"textContent"===e||"innerHTML"===e?r[e]=t[e]:r.setAttribute(e,t[e])}),e.appendChild(r),r}}]),e}(),s=(function(){function t(e,n){r(this,t),this.data=n,this.element=e,this.element.value=n,this.element.addEventListener("change",this,!1)}a(t,[{key:"handleEvent",value:function(e){switch(e.type){case"change":this.change(this.element.value)}}},{key:"change",value:function(e){this.data=e,this.element.value=e}}])}(),function(){function e(){r(this,e)}a(e,null,[{key:"ucfirst",value:function(e){return e.charAt(0).toUpperCase()+e.slice(1)}},{key:"toASCII",value:function(e){return e.charCodeAt(0)}}])}(),function(){function e(){r(this,e)}return a(e,null,[{key:"load",value:function(e){return t.get(e)}},{key:"removeTrailingSlash",value:function(e){return e.replace(/\/+$/,"")}},{key:"getName",value:function(e){return e.replace(/^.*[\\\/]/,"")}},{key:"getExtension",value:function(e){return e.split(".").pop()}},{key:"getDirectory",value:function(e){return e.replace(/[^\\\/]*$/,"")}},{key:"checkExtension",value:function(e,n){var t=!0,r=!1,i=void 0;try{for(var o,u=n[Symbol.iterator]();!(t=(o=u.next()).done);t=!0){if(e===o.value)return!0}}catch(e){r=!0,i=e}finally{try{!t&&u.return&&u.return()}finally{if(r)throw i}}return!1}}]),e}()),f=(function(){function e(){r(this,e)}a(e,null,[{key:"load",value:function(r){return new Promise(function(e,n){var t=new Image;t.src=r,t.name=s.getName(r),t.addEventListener("load",function(){e(t)}),t.addEventListener("error",function(){n(new Error("xhr failed ("+r+")"))})})}}])}(),function(){function e(){r(this,e)}a(e,null,[{key:"load",value:function(r){return new Promise(function(e,n){var t=new Audio;t.src=r,t.addEventListener("canplaythrough",function(){e(t)},!1),t.addEventListener("canplay",function(){e(t)},!1),t.addEventListener("error",function(){n(new Error("xhr failed ("+r+")"))},!1)})}}])}(),"function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e}),y=function(){function r(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,n,t){return n&&r(e.prototype,n),t&&r(e,t),e}}(),v=(function(){function e(){i(this,e)}y(e,null,[{key:"isJSON",value:function(e){var n=e.replace(/(\r\n|\n|\r|\t)/gm,"");try{n=JSON.parse(e)}catch(e){return!1}return n}},{key:"isFunction",value:function(e){return e&&"[object Function]"==={}.toString.call(e)}},{key:"isObject",value:function(e){return null!==e&&(this.isFunction(e)||"object"===(void 0===e?"undefined":f(e)))}},{key:"isASCII",value:function(e,n){return(n?/^[\x00-\xFF]*$/:/^[\x00-\x7F]*$/).test(e)}},{key:"isInteger",value:function(e){return e===parseInt(e,10)}}])}(),function(){function e(){i(this,e)}return y(e,null,[{key:"scrollToBottom",value:function(e){e.scrollTop=e.scrollHeight}},{key:"findById",value:function(e){return document.getElementById(e)}},{key:"showById",value:function(e){this.findById(e).style.display="block"}},{key:"hideById",value:function(e){this.findById(e).style.display="none"}},{key:"showOverflow",value:function(){document.body.style.overflow="visible"}},{key:"hideOverflow",value:function(){document.body.style.overflow="hidden"}},{key:"getInputValue",value:function(e){return this.findById(e).value}},{key:"clearInputValue",value:function(e){this.findById(e).value=""}},{key:"focusOn",value:function(e){this.findById(e).focus()}},{key:"addHTMLElement",value:function(e,n,t){var r=document.createElement(n);return void 0!==t&&Object.keys(t).forEach(function(e){"textContent"===e?r.textContent=t[e]:r.setAttribute(e,t[e])}),e.appendChild(r),r}}]),e}()),d=(function(){function t(e,n){i(this,t),this.data=n,this.element=e,this.element.value=n,this.element.addEventListener("change",this,!1)}y(t,[{key:"handleEvent",value:function(e){switch(e.type){case"change":this.change(this.element.value)}}},{key:"change",value:function(e){this.data=e,this.element.value=e}}])}(),function(){function e(){i(this,e)}y(e,null,[{key:"ucfirst",value:function(e){return e.charAt(0).toUpperCase()+e.slice(1)}},{key:"toASCII",value:function(e){return e.charCodeAt(0)}}])}(),function(){function e(){i(this,e)}return y(e,null,[{key:"call",value:function(r){var i=this;return new Promise(function(e,n){var t=new XMLHttpRequest;i.noCache&&(r+="?cache="+(new Date).getTime()),t.open(i.method,r,i.async),t.setRequestHeader("Content-Type","application/x-www-form-urlencoded"),t.onreadystatechange=function(){4==t.readyState&&(200==t.status?e(t.responseText):n(t.status))},t.send()})}}]),e}());d.method="GET",d.async=!0,d.noCache=!1;var h=function(){function e(){i(this,e)}return y(e,null,[{key:"load",value:function(e){return d.call(e)}},{key:"removeTrailingSlash",value:function(e){return e.replace(/\/+$/,"")}},{key:"getName",value:function(e){return e.replace(/^.*[\\\/]/,"")}},{key:"getExtension",value:function(e){return e.split(".").pop()}},{key:"getDirectory",value:function(e){return e.replace(/[^\\\/]*$/,"")}},{key:"checkExtension",value:function(e,n){var t=!0,r=!1,i=void 0;try{for(var o,u=n[Symbol.iterator]();!(t=(o=u.next()).done);t=!0){if(e===o.value)return!0}}catch(e){r=!0,i=e}finally{try{!t&&u.return&&u.return()}finally{if(r)throw i}}return!1}}]),e}(),p=(function(){function e(){i(this,e)}y(e,null,[{key:"load",value:function(r){return new Promise(function(e,n){var t=new Image;t.src=r,t.name=h.getName(r),t.addEventListener("load",function(){e(t)}),t.addEventListener("error",function(){n(new Error("xhr failed ("+r+")"))})})}}])}(),function(){function e(){i(this,e)}y(e,null,[{key:"load",value:function(r){return new Promise(function(e,n){var t=new Audio;t.src=r,t.addEventListener("canplaythrough",function(){e(t)},!1),t.addEventListener("canplay",function(){e(t)},!1),t.addEventListener("error",function(){n(new Error("xhr failed ("+r+")"))},!1)})}}])}(),function(){function r(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,n,t){return n&&r(e.prototype,n),t&&r(e,t),e}}()),m=[{id:1,name:"info"},{id:2,name:"trace"},{id:3,name:"warn"},{id:4,name:"error"},{id:99,name:"off"}],k=function(){function t(e,n){o(this,t),this.setLevel(e),this.content=n}return p(t,[{key:"setLevel",value:function(e){this.level=this.findLevel(e)}},{key:"getLevelId",value:function(){return this.level.id}},{key:"display",value:function(){}},{key:"findLevel",value:function(e){var n=!0,t=!1,r=void 0;try{for(var i,o=m[Symbol.iterator]();!(n=(i=o.next()).done);n=!0){var u=i.value;if(u.name===e)return u}}catch(e){t=!0,r=e}finally{try{!n&&o.return&&o.return()}finally{if(t)throw r}}return this.level?this.level:m[0]}}]),t}(),b=function(){function r(){o(this,r)}return p(r,[{key:"level",set:function(e){r._level=r.findLevel(e)},get:function(){return r._level.name}}],[{key:"info",value:function(e){r.log("info",e)}},{key:"trace",value:function(e){r.log("trace",e)}},{key:"time",value:function(e){r.log("time",e)}},{key:"warn",value:function(e){r.log("warn",e)}},{key:"error",value:function(e){r.log("error",e)}},{key:"log",value:function(e,n){r.addMessage(e,n);var t=this.messages[this.nbMessages-1];this._level.id<=t.getLevelId()&&t.display()}},{key:"addMessage",value:function(e,n){this.messages.push(new k(e,n)),this.nbMessages++}},{key:"findLevel",value:function(e){var n=!0,t=!1,r=void 0;try{for(var i,o=m[Symbol.iterator]();!(n=(i=o.next()).done);n=!0){var u=i.value;if(u.name===e)return u}}catch(e){t=!0,r=e}finally{try{!n&&o.return&&o.return()}finally{if(t)throw r}}return this._level?this._level:m[0]}}]),r}();b._level=b.findLevel(m[0].name),b.messages=[],b.nbMessages=0,b.target=v.findById("Mouette");var g=function(){function e(){}return e.data=function(e,n,t){if(!l.isObject(n[0])&&!l.isJSON(n[0]))return!1;t&&this.setOptions(t);var r="data:"+this.options.data+";charset="+this.options.charset+",";return this.options.labels&&(r+=this.createLabels(n),b.info("[CSVx] "+e+" labels ready")),r+=this.createTable(n),b.info("[CSVx] "+e+" table ready"),this.download(r,e),!0},e.setOptions=function(e){for(var n in e)e.hasOwnProperty(n)&&this.options.hasOwnProperty(n)&&(this.options[n]=e[n])},e.download=function(e,n){var t=encodeURI(e),r=c.addHTMLElement(document.body,"a",{href:t,download:n+".csv"});r.click(),document.body.removeChild(r),b.info("[CSVx] "+n+" downloading")},e.createTable=function(e){for(var n="",t=0,r=e;t<r.length;t++){var i=r[t],o=l.isJSON(i)||i;if(!l.isObject(o))return n;var u="";for(var a in o)o.hasOwnProperty(a)&&(u+=this.createField(o[a]));n+=this.createRow(u)}return n},e.createLabels=function(e){var n=l.isJSON(e[0])||e[0],t="";for(var r in n)n.hasOwnProperty(r)&&(t+=this.createField(r));return this.createRow(t)},e.createRow=function(e){return e+this.options.CRLF},e.createField=function(e){return this.options.quote+e+this.options.quote+this.options.separator},e.options={data:"text/csv",charset:"utf-8",labels:!0,quote:'"',separator:",",CRLF:"\r\n"},e}();return e.Export=g,e}({});